package com.jiuqi.util.comparator;

import java.util.Comparator;

public final class IntegerComparator implements Comparator
{
    private boolean isDescOrder;
    
    public IntegerComparator() {
    }
    
    public IntegerComparator(final boolean isDescOrder) {
        this.isDescOrder = isDescOrder;
    }
    
    public int compare(final Object o1, final Object o2) {
        if (o1 == o2) {
            return 0;
        }
        int ret = 0;
        if (o1 == null) {
            ret = -1;
        }
        else if (o2 == null) {
            ret = 1;
        }
        else {
            ret = ((Integer)o1).compareTo((Integer)o2);
        }
        return this.isDescOrder ? (-ret) : ret;
    }
    
    @Override
    public boolean equals(final Object obj) {
        return this == obj || (this != null && obj != null && obj instanceof IntegerComparator && this.isDescOrder == ((IntegerComparator)obj).isDescOrder);
    }
    
    @Override
    public String toString() {
        return "[整数比较器, " + (this.isDescOrder ? "降序]" : "升序]");
    }
    
    public boolean isDescOrder() {
        return this.isDescOrder;
    }
    
    public void setDescOrder(final boolean isDescOrder) {
        this.isDescOrder = isDescOrder;
    }
}
